require "testlink_rspec_utils/version"
require 'xmlsimple'
require "erb"

module TestlinkRspecUtils
	# TestLink Project
	class Convert
		def requirements_to_cases(application, project, filein, fileout)

			$application_string = application
			$project = project

			$requirements=[]

			hash = XmlSimple.xml_in(filein)

			hash['requirement'].each do |req|

				requirement = {}
				requirement['short'] = req['title'][0] +' | ' + req['docid'][0]
				#   requirement['long'] = req['description'][0].gsub('\n', '').gsub('<p>','').gsub('\r','')
				requirement['long'] = ''
				requirement['cases'] = []
				i=1
				while i <= req['expected_coverage'][0].to_i do
					requirement['cases'] << req['docid'][0].gsub(/req/, "tc")+"-"+i.to_s.rjust(2, '0')
					i +=1
				end

				$requirements << requirement
			end
			
			renderer = ERB.new(IO.read(File.expand_path('../..',__FILE__)+"/lib/spec_template.erb"))
			output = renderer.result()

			File.open(fileout, 'w') { |file| file.write(output) }
		end
	end
end
